﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.5
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Type provider(Name As String, URL As String)
	
	Private providersList As List
	Private lang As String 
	Private appPrivacyPolicyURL As String
	Private adProvidersFilename As String
	Private appIconFilename As String
	Private appName As String
	Private changeAnytimePrev, changeAnytimePOST, howPartnersUse, howAppUsesPrev, howAppUsesPost As String
	Private btnBackText As String
	
	
	Private btnBack As B4XView
	Private btnBackWeb As B4XView
	Private lblPolicyLink As B4XView
	Private lblText As B4XView
	Private lblHeader As B4XView
	Private pnlProviders As B4XView
	Private svProviders As B4XView
		
	#if b4i
		Dim WebView1 As WkWebview
	#else
		Dim WebView1 As WebView
	#end if
	
End Sub

'You can add more parameters here.
Public Sub Initialize
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)

	Root = Root1
	Root.LoadLayout("ShowProviders")
	Root.Visible = False
	pnlProviders.SetLayoutAnimated(0, Root.Left, Root.Top, Root.Width, Root.Height)
	
	appName = B4XPages.MainPage.TheConsentPage.AppName
	appPrivacyPolicyURL = B4XPages.MainPage.TheConsentPage.PrivacyURL
	appIconFilename = B4XPages.MainPage.TheConsentPage.appIconFilename
	adProvidersFilename = B4XPages.MainPage.TheConsentPage.adProvidersFilename
	lang = B4XPages.MainPage.TheConsentPage.langCode
		
	SetPage
	
	
End Sub

Private Sub B4XPage_Appear
	
	Root.Visible = True	
	
End Sub

Private Sub SetPage
	
	GetTexts(lang)
	GetProvidersData
	
	Private btnsHeight  As Int = pnlProviders.Height * .06
	Private titleHeight As Int = pnlProviders.Height * .06	
	Private textHeight  As Int = pnlProviders.Height * .15
	Private linkPolicyHeight As Int = pnlProviders.Height * .06
	
	Private mrg As Int = pnlProviders.Width * .04
	Private itemWidth As Int = pnlProviders.Width * .92 - 2 * mrg
		
 ' Calculate height for all labels - Fonts and font sizes are set in the Designer
 	lblHeader.Width = itemWidth
	lblText.Width  = itemWidth
	lblPolicyLink.Width  = itemWidth

	Private textProviders As String = $"${changeAnytimePrev}${appName}${changeAnytimePOST}${howPartnersUse}"$
	
	Private textPolicy As String = $"${howAppUsesPrev}${appName}${howAppUsesPost}"$
		
	pnlProviders.SetLayoutAnimated(0, pnlProviders.Width * .04, pnlProviders.Height * .03, pnlProviders.Width * .92, pnlProviders.Height * .94)

	lblHeader.SetLayoutAnimated(0, mrg, 5dip,								    			    itemWidth, titleHeight)
	lblText.SetLayoutAnimated (0, mrg, lblHeader.Top + lblHeader.Height + mrg, itemWidth, textHeight)
		
	Private btnWidth As Int = 100dip
	Private leftbtnBack As Int = (pnlProviders.Width - btnWidth)/2
	Private topBtnBack As Int = pnlProviders.Height - mrg - btnsHeight
	
	btnBack.SetLayoutAnimated(0, leftbtnBack, topBtnBack, btnWidth, btnsHeight)
	lblPolicyLink.SetLayoutAnimated(0, mrg, btnBack.Top - mrg - linkPolicyHeight, itemWidth, linkPolicyHeight)
		
	Private svProvidersHeight As Int = lblPolicyLink.Top - lblText.Top - lblText.Height - 2 * mrg		
	svProviders.SetLayoutAnimated (0, mrg, lblText.Top + lblText.Height + mrg, itemWidth, svProvidersHeight)
	
	Private btnPubLeft As Int = 0
	Private btnPubTop As Int = 0
	Private btnPubHeight As Int = btnBack.Height
	Private btnPadding As Int = 7dip
	Private gapHorizBtns As Int = 4dip
	Private gapVertBtns As Int = 6dip
	
	svProviders.ScrollViewContentWidth = svProviders.Width
	svProviders.ScrollViewContentHeight = btnPubHeight + gapVertBtns
	
	For i = 0 To providersList.Size - 1
		
		Private lblPub As Label
				lblPub.Initialize("btnPub")
		
    	Private btnPub As B4XView = lblPub
    	svProviders.ScrollViewInnerPanel.AddView(btnPub, 0, 0, 10dip, 10dip)
		
				btnPub.Font = lblText.Font
				btnPub.SetTextAlignment("CENTER", "CENTER")
				btnPub.TextColor = lblText.TextColor
						
				Private provider As provider = providersList.Get(i)
				btnPub.Text = provider.Name
				btnPub.Tag  = provider.URL
					
		Private cnv As B4XCanvas
				cnv.Initialize(btnPub)
					
		Private rectText As B4XRect = cnv.MeasureText(btnPub.Text, btnPub.font)
		Private btnPubWidth As Int = rectText.Width + 2 * btnPadding
		
		If btnPubLeft + btnPubWidth > svProviders.Width Then
			btnPubLeft = 0
			btnPubTop = btnPubTop + gapVertBtns + btnPubHeight
			svProviders.ScrollViewContentHeight = svProviders.ScrollViewContentHeight + gapVertBtns + btnPubHeight
		End If
		
		btnPub.SetLayoutanimated(0, btnPubLeft, btnPubTop, btnPubWidth, btnPubHeight)
		btnPub.SetColorAndBorder(xui.Color_Transparent, Min(1, 1dip), btnPub.TextColor, 8dip)
			
		btnPubLeft = btnPubLeft + btnPubWidth + gapHorizBtns
				
	Next	
			
 ' TEXTS
 	
	If appIconFilename <> "" Then
 		SetHeaderWithIcon
	Else
		lblHeader.Text = appName
	End If
	
	lblText.Text 	 = textProviders
	lblPolicyLink.Text 	 = textPolicy
	btnBack.Text 	 = $"<  ${btnBackText}"$
		
	
End Sub


Private Sub SetHeaderWithIcon
	
	Private appIcon As B4XBitmap = xui.LoadBitmapResize(File.DirAssets, appIconFilename, 50dip, 50dip, True)
	
	Private iconMargin As Int = lblHeader.Height * .05 'top and bottom margin from border to icon
	Private IcSize     As Int = lblHeader.Height - 2 * iconMargin
	Private iconTextSeparation As Int = 5dip	
	
	Private cnv As B4XCanvas 
			cnv.Initialize(lblHeader)

	Private txtRect As B4XRect = cnv.MeasureText(appName, lblHeader.Font)
	Private baseText  As Int = (lblHeader.height + txtRect.Height)/2
	Private lefticon  As Int
			lefticon = (lblHeader.Width - (IcSize + iconTextSeparation + txtRect.Width))/2
	Private leftText  As Int 
			leftText = lefticon + IcSize + iconTextSeparation
	
' Icon:
	Private destIconRect As B4XRect
	Private semiDiff, dist As Int

 ' Keep icon aspect ratio for non-square bitmaps. Otherwise it will fit IcSize x IcSize
	If appIcon.Width >= appIcon.Height Then 
		semiDiff = (appIcon.Width - appIcon.Height)/2
		dist = IcSize * semiDiff/appIcon.Width
		destIconRect.Initialize(lefticon, iconMargin + dist, lefticon + IcSize, iconMargin + IcSize - dist)
	Else	
		semiDiff = (appIcon.Height - appIcon.width)/2
		dist = IcSize * semiDiff/appIcon.Height
		destIconRect.Initialize(lefticon + dist, iconMargin, lefticon + IcSize - dist, iconMargin + IcSize)
	End If
					
	cnv.DrawBitmap(appIcon, destIconRect)
	cnv.DrawText(appName, leftText, baseText, lblHeader.font, lblHeader.TextColor, "LEFT")

End Sub


Private Sub GetProvidersData '(sorted)
	
	Private su As StringUtils
	Private rawList As List = su.LoadCSV(File.DirAssets, adProvidersFilename, ",")
	
 ' The first item in the list obtained from AdMob console contains the fields names
	rawList.RemoveAt(0)

 ' Create providersList with known fields names...
 	providersList.Initialize
	For Each row() As String In rawList
		Private provider As provider
				provider.Initialize
				provider.Name = row(0)
				provider.URL  = row(1)
		providersList.Add(provider)
	Next	
	
 ' ...and sort providersList by field 'Name'
	providersList.SortTypeCaseInsensitive("Name", True)
	
End Sub

Sub OpenURL(url As String)
	pnlProviders.Visible = False
	
	Root.LoadLayout("b4xAdConsent")
		
	btnBackWeb.Text = Chr(0xF060)
	btnBackWeb.Visible = True
	
	WebView1.LoadUrl(url)	
		
End Sub

Private Sub btnPub_Click
	Private s As B4XView = Sender
	OpenURL(s.Tag)	
End Sub

Private Sub btnBackWeb_Click
	WebView1.RemoveView
	btnBackWeb.RemoveViewFromParent
	pnlProviders.Visible = True	
End Sub


Private Sub lblPolicyLink_Click
	OpenURL(appPrivacyPolicyURL)
End Sub

Private Sub btnBack_Click
	B4XPages.ClosePage(Me)
End Sub

Sub GetTexts(langCode As String)
	
	Select langCode
	   	Case "es"	
			changeAnytimePrev = "Puedes cambiar tu elección para "
			changeAnytimePOST = " en cualquier momento desde los ajustes de la aplicación. "
			howPartnersUse	  = "Descubre cómo nuestros colaboradores recogen y usan los datos:"
			howAppUsesPrev	  = "Cómo utiliza "
			howAppUsesPost	  = " tus datos"
			btnBackText  	  = "Atrás"
			
		Case "fr"
			changeAnytimePrev = "Vous pouvez modifier votre choix à tout moment pour "
			changeAnytimePOST = " dans les réglages de l'application. "
			howPartnersUse	  = "Découvrez comment nos partenaires recueillent et utilisent les données :"
			howAppUsesPrev	  = "Comment "
			howAppUsesPost	  = " utilise vos données"
			btnBackText  	  = "Retour"
		
		Case "pt"
			changeAnytimePrev = "Pode alterar a sua opção a qualquer momento para "
			changeAnytimePOST = " nas definições da aplicação. "
			howPartnersUse	  = "Saiba como os nossos parceiros recolhem e utilizam dados:"
			howAppUsesPrev	  = "Como "
			howAppUsesPost	  = "  utiliza os seus dados"
			btnBackText  	  = "Anterior"
			
		Case "it"	
			changeAnytimePrev = "Puoi modificare la tua scelta per "
			changeAnytimePOST = " in qualsiasi momento dalle impostazioni dell'app. " 
			howPartnersUse	  = "Scopri in che modo i nostri partner raccolgono e usano i dati:"
			howAppUsesPrev	  = "In che modo "
			howAppUsesPost	  = "  usa i tuoi dati"
			btnBackText  	  = "Indietro"

		Case "de"
			changeAnytimePrev = "Sie können Ihre Auswahl für "
			changeAnytimePOST = " jederzeit in den App-Einstellungen ändern. "
			howPartnersUse	  = "Lernen Sie, wie unsere Partner Daten sammeln und nutzen:"
			howAppUsesPrev	  = "Wie "
			howAppUsesPost	  = " Ihre Daten verwendet"
			btnBackText  	  = "Zurück"

		Case "ru"
			changeAnytimePrev = "Вы можете изменить свой выбор в любое время для "
			changeAnytimePOST = " в настройках приложения. "
			howPartnersUse	  = "Узнайте, как наши партнеры собирают и используют данные:"
			howAppUsesPrev	  = "Как "
			howAppUsesPost	  = " использует ваши данные"
			btnBackText  	  = "Назад"

		Case "nl"
			changeAnytimePrev = "U kunt in de instellingen van "			
			changeAnytimePOST = " uw keuze altijd aanpassen. "
			howPartnersUse	  = "Meer informatie over hoe onze partners gegevens verzamelen en gebruiken:"
			howAppUsesPrev	  = "Hoe "
			howAppUsesPost	  = " uw gegevens gebruikt"
			btnBackText  	  = "Terug"

		Case "cn"	
			changeAnytimePrev = "您可随时前往应用设置，更改 "
			changeAnytimePOST = " 中的相关选择。 "
			howPartnersUse	  = "了解我们的合作伙伴如何收集和使用数据："
			howAppUsesPrev	  = ""
			howAppUsesPost	  = " 如何使用您的数据"
			btnBackText  	  = "返回"

		Case "jp"
			changeAnytimePrev = "アプリの設定で "
			changeAnytimePOST = " の選択をいつでも変更できます。 "
			howPartnersUse	  = "私どものパートナーがデータを収集し使用する方法をご覧ください:"
			howAppUsesPrev	  = ""
			howAppUsesPost	  = " があなたのデータを使用する方法"
			btnBackText  	  = "戻る"

		Case "ko"
			changeAnytimePrev = "언제든 앱 설정에서 "
			changeAnytimePOST = " 에 대한 선택 사항을 변경하실 수 있습니다. "
			howPartnersUse	  = "당사의 협력업체가 데이터를 수집 및 이용하는 방법 보기:"
			howAppUsesPrev	  = ""
			howAppUsesPost	  = " 의 개인 정보 이용 방법"
			btnBackText  	  = "뒤로"

		Case Else	' "en"(english, default) and rest of codes
			changeAnytimePrev = "You can change your choice anytime for "
			changeAnytimePOST = " in the app settings. "
			howPartnersUse	  = "Learn how our partners collect and use data:"
			howAppUsesPrev	  = "How "
			howAppUsesPost	  = " uses your data"
			btnBackText  	  = "Back"
			
			
	End Select
	
			
End Sub